using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

using ISummary = Syncfusion.Collections.BinaryTree.ITreeTableSummary;

namespace GGCSummary3
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.TextBox TextBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.TextBox1 = new System.Windows.Forms.TextBox();
            ( (System.ComponentModel.ISupportInitialize)( this.gridGroupingControl1 ) ).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( ( ( System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom )
                        | System.Windows.Forms.AnchorStyles.Left )
                        | System.Windows.Forms.AnchorStyles.Right ) ) );
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point( 48, 48 );
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size( 432, 288 );
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.TableControlCurrentCellAcceptedChanges += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler( this.gridGroupingControl1_TableControlCurrentCellAcceptedChanges );
            this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler( this.gridGroupingControl1_QueryCellStyleInfo );
            // 
            // TextBox1
            // 
            this.TextBox1.Location = new System.Drawing.Point( 265, 9 );
            this.TextBox1.Multiline = true;
            this.TextBox1.Name = "TextBox1";
            this.TextBox1.Size = new System.Drawing.Size( 160, 20 );
            this.TextBox1.TabIndex = 2;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 );
            this.ClientSize = new System.Drawing.Size( 520, 374 );
            this.Controls.Add( this.TextBox1 );
            this.Controls.Add( this.gridGroupingControl1 );
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler( this.Form1_Load );
            ( (System.ComponentModel.ISupportInitialize)( this.gridGroupingControl1 ) ).EndInit();
            this.ResumeLayout( false );
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 50;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(10);
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;

			
			//set up the cummary column and row
			GridSummaryColumnDescriptor wgtSum = new GridSummaryColumnDescriptor();
			wgtSum.Name = "Col2";
			wgtSum.DataMember = "Col2";
			wgtSum.DisplayColumn = "Col2";
			wgtSum.Format = "{Sum:#.##}";
			wgtSum.SummaryType = SummaryType.Int32Aggregate;
			wgtSum.Appearance.AnySummaryCell.HorizontalAlignment = GridHorizontalAlignment.Right;
			this.TextBox1.TextAlign = HorizontalAlignment.Right;
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("Row 0",  wgtSum));

			this.gridGroupingControl1.TableModel.QueryRowHeight +=new GridRowColSizeEventHandler(TableModel_QueryRowHeight);

            this.gridGroupingControl1.TableControlPrepareViewStyleInfo += new GridTableControlPrepareViewStyleInfoEventHandler(gridGroupingControl1_TableControlPrepareViewStyleInfo);  
		}

        void gridGroupingControl1_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
        {
            GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.SummaryFieldCell)
            {
                e.Inner.Style.CellType = "Control";
                e.Inner.Style.Control = this.TextBox1;
                e.Inner.Style.Enabled = true;

                if (oldValue != e.Inner.Style.Text)
                {
                    oldValue = e.Inner.Style.Text;
                    this.TextBox1.Text = e.Inner.Style.Text;
                }
            }
        }
		string oldValue = string.Empty;
		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if( e.TableCellIdentity.TableCellType == GridTableCellType.SummaryFieldCell )
			{
				e.Style.CellType = "Control";
                e.Style.Control = this.TextBox1; 
				e.Style.Enabled = true;
				
				if( oldValue != e.Style.Text )
				{
					oldValue = e.Style.Text;
                    this.TextBox1.Text = e.Style.Text;
				}
			}
		}

		private void TableModel_QueryRowHeight(object sender, GridRowColSizeEventArgs e)
		{
			GridTableModel tm = sender as GridTableModel;
			if( tm.Table.DisplayElements[e.Index].Kind == DisplayElementKind.Summary )
			{
				e.Size = 0;
				e.Handled = true;
			}
		}

        private void gridGroupingControl1_TableControlCurrentCellAcceptedChanges(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
        {
            SummaryDescriptorCollection sdc = this.gridGroupingControl1.TableDescriptor.Summaries;

            ISummary[] summaries = this.gridGroupingControl1.Table.GetSummaries();
            //if you want to Get the name of the summary using SummaryDescriptor.Name 
            //foreach (SummaryDescriptor sd in sdc)
            //    Console.WriteLine(sd.Name);
            int index = sdc.IndexOf(sdc["Row 0Col2"]);
            Int32AggregateSummary summary = summaries[index] as Int32AggregateSummary;
            
            summary = summaries[index] as Int32AggregateSummary;
            this.TextBox1.Text = summary.Sum.ToString();
        }
	}
}
